package com.falcon.core;

import java.lang.reflect.Array;

import org.apache.log4j.Logger;

public class DataTypeConvertor {
    private static Logger log = Logger.getLogger("com.twine.core.util.DataTypeConvertor");

    private DataTypeConvertor() {
    }

    public static Class getDataTypeClass(String dataType, boolean isArray) {
        Class convertedClass = null;

        if (dataType.equals("xs:string")) {
            convertedClass = String.class;
        } else if (dataType.equals("xs:int")) {
            convertedClass = Integer.class;
        } else if (dataType.equals("xs:integer")) {
            convertedClass = Integer.class;
        } else if (dataType.equals("xs:long")) {
            convertedClass = Long.class;
        } else if (dataType.equals("xs:character")) {
            convertedClass = Character.class;
        }
        
        if(isArray)convertedClass = getArrayClass(convertedClass);

        return convertedClass;
    }

    public static Object convertDataTypeData(String argData, String dataType) {
        log.debug("convertDataTypeData called " + argData + " type " + dataType);
        Object returnData = null;
        
        if (dataType.equals("xs:string")) {
            returnData = argData;
        } else if (dataType.equals("xs:int") || 
                dataType.equals("xs:integer")) {
            returnData = Integer.valueOf(argData);
        } else if (dataType.equals("xs:long")) {
            returnData = Long.valueOf(argData);
        } else if (dataType.equals("xs:character")) {
            returnData = Character.valueOf(argData.toCharArray()[0]);
        }

        if (returnData == null) log.error("could not find data type returning NULL " + dataType);
        return returnData;
    }
    
    public static Class getArrayClass(Class classToBeArray){
        Class arClass = null;
            
            arClass = Array.newInstance(classToBeArray, 0).getClass();
        
        return arClass;
    }

}
