package com.falcon.core.util;

import com.falcon.core.FalconAssembler;
import com.falcon.core.FalconRunner;
import com.falcon.core.exception.FalconCoreException;
import org.apache.log4j.Logger;


/**
 * User: Charlie
 * Date: 25-Jan-2006
 * Time: 12:36:30
 */
public class FalconCoreFactory {

    private FalconCoreFactory() {
    }

    private static Logger log = Logger.getLogger("com.falcon.core.util.FalconCoreFactory");


    public static FalconRunner getFalconRunner(String falconFileLoc) {
        log.info("loading falcon file " + falconFileLoc);
        try {
            return FalconAssembler.getInstance(FalconLoader.getBindingConfig(falconFileLoc));
        } catch (FalconCoreException e) {
            log.error("problem with loading falcon file", e);
        }
        return null;
    }
}
